#include <assert.h>
/* only use assert (0) */
#undef NDEBUG

#include <stdbool.h>
#include <stdint.h>
#include <stddef.h>

typedef intptr_t natint;
typedef int32_t int32;
typedef int64_t int64;

#define __max(a,b) (((a) > (b)) ? (a) : (b))
#define __min(a,b) (((a) < (b)) ? (a) : (b))

/* raise exn */
void failwith (const char *msg) __attribute__ ((noreturn));
#define error(fun_name, msg) failwith (fun_name ": " msg)

char failbuf[512];			/* to snprintf the failwith msg */
#define failwithf(format, ...) failwith((snprintf (failbuf, sizeof (failbuf), format, __VA_ARGS__), failbuf))

/* unconditional abort */
void invalid_argument (const char *msg) __attribute__ ((noreturn));

struct string {
  size_t ssize;
  char *str;
};
int string_cmp (struct string *s1, struct string *s2);
#define string_equal(s1, s2) (string_cmp (s1, s2) == 0)
int sstring_cmp (struct string s1, struct string s2);
#define sstring_equal(s1, s2) (sstring_cmp (s1, s2) == 0)

bool binary_mode, report_mode, debug_mode;
#define ascii_mode (!binary_mode)
